unit t_SluckovaniDialog;

interface
uses
   f_SluckovaniDialog,
   t_OrbisDialog;

type

TSluckovaniDialog = class(TOrbisDialog)
private
    function GetForm: TSluckovaniDialog_Form;
    function GetSlucka: boolean;
    procedure SetSlucka(const Value: boolean);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TSluckovaniDialog_Form read GetForm;
published
   property Slucka: boolean read GetSlucka write SetSlucka;
end;

implementation
uses
   Forms,
   e_Class;

{ TSluckovaniDialog }

procedure TSluckovaniDialog.CreateForm;
begin
   aForm := TSluckovaniDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TSluckovaniDialog.DoIt;
begin
  inherited;
end;

function TSluckovaniDialog.GetForm: TSluckovaniDialog_Form;
begin
   result := TSluckovaniDialog_Form(aForm);
end;

function TSluckovaniDialog.GetSlucka: boolean;
begin
   result := false;
   if Form = nil then exit;
   result := Form.cb_Slucka.Checked;
end;

procedure TSluckovaniDialog.SetSlucka(const Value: boolean);
begin
   if Form = nil then exit;
   Form.cb_Slucka.Checked := Value;
end;


INITIALIZATION
   RegisterOrbisClass(TSluckovaniDialog);
END.
