unit RasOpDLL;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses
     WinTypes, StrProc, Header, FuncType, TranType, MatProc, RasGlob,
     BlokType, Prostypy, BlokPred;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

function TransformaceInit(
                          PoleIdBodu       : PExtVector;
                          PocetDvojicIdBodu: integer;
                          Typ              : byte): pointer;

(*
  Typ = 0 Podobn 2D
  Typ = 1 Afinn  2D
  Typ = 2 Kolin  2D
  Typ = 3 Podobn 3D
  Typ = 4 Afinn  3D
  Typ = 5 Kolin  3D
  Typ = 6 2 St Pol
  Typ = 7 3 St Pol
*)

procedure TransformaceDone(
                           var Tran: pointer);

procedure TransformaceTransformuj(
                                        Tran    : pointer;
                                  const ZdrojBod: Bod;
                                  var   CilBod  : Bod);

procedure TransformaceInvTransformuj(
                                           Tran    : pointer;
                                     const ZdrojBod: Bod;
                                     var   CilBod  : Bod);

function TransformaceDejPocetIdB(
                                 Tran: pointer): integer;

function TransformaceVratCisloChyby(
                                    Tran: pointer): integer;

function TransformaceKlicVypocten(
                                  Tran: pointer): boolean;

function TransformaceVratPopisChyby(
                                    Tran: pointer): string;

procedure TransformaceDejZdrojStred(
                                    Tran: pointer; var Bod: TranType.Bod);

procedure TransformaceDejCilStred(
                                  Tran: pointer; var Bod: TranType.Bod);

procedure TransformaceDejNov(
                             Tran: pointer; i: integer; var Bod: TranType.Bod);

procedure TransformaceDejSta(
                             Tran: pointer; i: integer; var Bod: TranType.Bod);

procedure TransformaceZmenNov(
                              Tran: pointer; Puv, No: integer);

procedure TransformaceZmenSta(
                              Tran: pointer; Puv, No: integer);

procedure TransformaceNastavPocetIdBodu(
                                        Tran: pointer; aPocetIdBodu: integer);

function TransformaceDejNazevTransformace(
                                          Tran: pointer): PChar;

function TransformaceDejNazevTransfTabulky(
                                           Tran: pointer): PChar;

procedure TransformaceDejSourRohu(
                                  Tran: pointer; var aSourRohy: TObdelnik);

procedure TransformaceNastavNazevTransformace(
                                              Tran: pointer; aNazevTransformace: PChar);

procedure TransformaceNastavNazevTransfTabulky(
                                               Tran: pointer; aNazevTransfTabulky: PChar);

procedure TransformaceNastavSourRohu(
                                     Tran: pointer; aSourRohy: TObdelnik);

function TransformaceDejInvKlic(
                                Tran: pointer; i: integer): extended;

{MyStLib}

{$IFNDEF Tiles}

function  PPRStreamRasInit(Filename: TPathStr ; ABufSize, Adif: word): pointer;

function  PPWStreamInit(Filename: TPathStr ; aTypSou, aRowByteCount,
                        AHeaderSize: Word; ABufSize: Word): pointer;

function  PPRWStreamInit(Filename: TPathStr;
                         ABufSize: Word): pointer;

function  MyStreamStatus(MyStr: pointer): integer;

procedure MyStreamDone(var MyStr: pointer);

procedure PPWStreamStreamDone(var MyStr: pointer); far;

procedure PPWStreamPisHeader(MyStr: pointer; var Headrec); far;

procedure PPWStreamNastavRadPtr(MyStr: pointer; var Ukaz: pointer); far;

function  PPRWStreamIsBit4(MyStr: pointer): boolean; far;

{$ENDIF}

procedure BinMirrorLine(var Source; var line;  VAR MEZE; Pocet: Word); far;


{PTranPoR}

procedure TransformaceNastavInvKlic(
                                    Tran: pointer; i: integer; InvKl: extended);

procedure TransformaceNastavKlic(
                                 Tran: pointer; i: integer; Kl: extended);

procedure TransformaceNastavZdrojStred(
                                       Tran: pointer; Bod: TranType.Bod);

procedure TransformaceNastavCilStred(
                                     Tran: pointer; Bod: TranType.Bod);

procedure TransformaceNastavNov(
                                Tran: pointer; i: integer; Bod: TranType.Bod);

procedure TransformaceNastavSta(
                                Tran: pointer; i: integer; Bod: TranType.Bod);

function TransformaceDejKlic(
                             Tran: pointer; i: integer): extended;

function TransformaceDejDimenzi(
                                Tran: pointer): byte;


procedure NastavSourSystemDoRas_DLL(
                                    aSourSystem: TSourSystem); far;




function SingleRasIteratorInit(
                     aZrusitDekomprimovane: boolean;

                     aInitAbortNMCallBackPr,
                     aZmenTitleAbortNMCallBackPr,
                     aBylUserAbortAbortNMCallBackNovyPr,
                     aDisposeAbortNMCallBackPr: TFunctionDLL;
                     {$IFNDEF MBFil}
                     aHWindow: HWnd;
                     {$ENDIF}
                     const aJmenoObrazu1, aJmenoNovSouboru: TPathStr;
                     Metoda: byte; aOutputType: word;
                     aMeze: PMeze;
                     aPaleta: Paleta2Ptr
            {$IFDEF Tiles}
                    ; aKomprimovat: boolean
            {$ENDIF}
                     ): pointer; far;
function SingleRasIteratorRun(Op: pointer): integer; far;
procedure SingleRasIteratorDone(Op: pointer); far;


function DoubleRasIteratorInit(
                     aZrusitDekomprimovane: boolean;

                     aInitAbortNMCallBackPr,
                     aZmenTitleAbortNMCallBackPr,
                     aBylUserAbortAbortNMCallBackNovyPr,
                     aDisposeAbortNMCallBackPr: TFunctionDLL;
                     {$IFNDEF MBFil}
                     aHWindow: HWnd;
                     {$ENDIF}
                     const aJmenoObrazu1, aJmenoObrazu2, aJmenoNovSouboru: TPathStr;
                     Metoda: byte; aOutputType: word): pointer; far;
function DoubleRasIteratorRun(Op2: pointer): integer; far;
procedure DoubleRasIteratorDone(Op2: pointer); far;


function RasIteratorGetFlag(Op: pointer): boolean; far;

function SingleRasElemIteratorInit(
                     aZrusitDekomprimovane: boolean;

                     aInitAbortNMCallBackPr,
                     aZmenTitleAbortNMCallBackPr,
                     aBylUserAbortAbortNMCallBackNovyPr,
                     aDisposeAbortNMCallBackPr: TFunctionDLL;
                     const aJmenoObrazu1, aJmenoNovSouboru: TPathStr;
                     Metoda: byte; aOutputType: word;
                     aMeze: PMeze;
                     aPaleta: Paleta2Ptr
                     ): pointer; far;

function SingleRasElemIteratorRun(Op: pointer): integer; far;




procedure  SetHlaskaRasOpLib(RasWork, HlaskWin: boolean); far;


implementation

function TransformaceInit(
                          PoleIdBodu       : PExtVector;
                          PocetDvojicIdBodu: integer;
                          Typ              : byte): pointer; external 'RASOPLIB' index 21;

procedure TransformaceDone(
                           var Tran: pointer); external 'RASOPLIB' index 22;

procedure TransformaceTransformuj(
                                        Tran    : pointer;
                                  const ZdrojBod: Bod;
                                  var   CilBod  : Bod); external 'RASOPLIB' index 23;

procedure TransformaceInvTransformuj(
                                           Tran    : pointer;
                                     const ZdrojBod: Bod;
                                     var   CilBod  : Bod); external 'RASOPLIB' index 24;


function TransformaceDejPocetIdB(
                                 Tran: pointer): integer; external 'RASOPLIB' index 25;

function TransformaceVratCisloChyby(
                                    Tran: pointer): integer; external 'RASOPLIB' index 26;

function TransformaceKlicVypocten(
                                  Tran: pointer): boolean; external 'RASOPLIB' index 27;

function TransformaceVratPopisChyby(
                                    Tran: pointer): string; external 'RASOPLIB' index 28;

procedure TransformaceDejZdrojStred(
                                    Tran: pointer; var Bod: TranType.Bod); external 'RASOPLIB' index 29;

procedure TransformaceDejCilStred(
                                  Tran: pointer; var Bod: TranType.Bod); external 'RASOPLIB' index 30;

procedure TransformaceDejNov(
                             Tran: pointer; i: integer; var Bod: TranType.Bod); external 'RASOPLIB' index 31;

procedure TransformaceDejSta(
                             Tran: pointer; i: integer; var Bod: TranType.Bod); external 'RASOPLIB' index 32;

procedure TransformaceZmenNov(
                              Tran: pointer; Puv, No: integer); external 'RASOPLIB' index 33;

procedure TransformaceZmenSta(
                              Tran: pointer; Puv, No: integer); external 'RASOPLIB' index 34;

procedure TransformaceNastavPocetIdBodu(
                                        Tran: pointer; aPocetIdBodu: integer); external 'RASOPLIB' index 35;

function TransformaceDejNazevTransformace(
                                          Tran: pointer): PChar; external 'RASOPLIB' index 36;

function TransformaceDejNazevTransfTabulky(
                                           Tran: pointer): PChar; external 'RASOPLIB' index 37;

procedure TransformaceDejSourRohu(
                                  Tran: pointer; var aSourRohy: TObdelnik); external 'RASOPLIB' index 38;

procedure TransformaceNastavNazevTransformace(
                                              Tran: pointer; aNazevTransformace: PChar); external 'RASOPLIB' index 39;

procedure TransformaceNastavNazevTransfTabulky(
                                               Tran: pointer; aNazevTransfTabulky: PChar); external 'RASOPLIB' index 40;

procedure TransformaceNastavSourRohu(
                                     Tran: pointer; aSourRohy: TObdelnik); external 'RASOPLIB' index 41;

function TransformaceDejInvKlic(
                                Tran: pointer; i: integer): extended; external 'RASOPLIB' index 42;

{$IFNDEF Tiles}

function  PPRStreamRasInit(Filename: TPathStr ; ABufSize, Adif: word): pointer; external 'RASOPLIB' index 43;

function  PPWStreamInit(Filename: TPathStr ; aTypSou, aRowByteCount,
                        AHeaderSize: Word; ABufSize: Word): pointer; external 'RASOPLIB' index 44;

function  PPRWStreamInit(Filename: TPathStr ; ABufSize: Word): pointer; external 'RASOPLIB' index 45;

function  MyStreamStatus(MyStr: pointer): integer; external 'RASOPLIB' index 46;

procedure MyStreamDone(var MyStr: pointer); external 'RASOPLIB' index 47;

procedure PPWStreamStreamDone(var MyStr: pointer); external 'RASOPLIB' index 63;

procedure PPWStreamPisHeader(MyStr: pointer; var Headrec); external 'RASOPLIB' index 64;

procedure PPWStreamNastavRadPtr(MyStr: pointer; var Ukaz: pointer); external 'RASOPLIB' index 65;

function  PPRWStreamIsBit4;                            external 'RASOPLIB' index 125;

{$ENDIF}

procedure BinMirrorLine(var Source; var line;  VAR MEZE; Pocet: Word); external 'RASOPLIB' index 66;

procedure TransformaceNastavInvKlic(
                                    Tran: pointer; i: integer; InvKl: extended); external 'RASOPLIB' index 49;

procedure TransformaceNastavKlic(
                                 Tran: pointer; i: integer; Kl: extended); external 'RASOPLIB' index 50;

procedure TransformaceNastavZdrojStred(
                                       Tran: pointer; Bod: TranType.Bod); external 'RASOPLIB' index 51;

procedure TransformaceNastavCilStred(
                                     Tran: pointer; Bod: TranType.Bod); external 'RASOPLIB' index 52;

procedure TransformaceNastavNov(
                                Tran: pointer; i: integer; Bod: TranType.Bod); external 'RASOPLIB' index 53;

procedure TransformaceNastavSta(
                                Tran: pointer; i: integer; Bod: TranType.Bod); external 'RASOPLIB' index 54;


function TransformaceDejKlic(
                             Tran: pointer; i: integer): extended; external 'RASOPLIB' index 55;

function TransformaceDejDimenzi(
                                Tran: pointer): byte; external 'RASOPLIB' index 56;


procedure NastavSourSystemDoRas_DLL(
                                    aSourSystem: TSourSystem); external 'RASOPLIB' index 69;


function SingleRasIteratorInit;                        external 'RASOPLIB' index 118;
function SingleRasIteratorRun;                         external 'RASOPLIB' index 119;
procedure SingleRasIteratorDone;                       external 'RASOPLIB' index 120;

function DoubleRasIteratorInit;                        external 'RASOPLIB' index 121;
function DoubleRasIteratorRun;                         external 'RASOPLIB' index 122;
procedure DoubleRasIteratorDone;                       external 'RASOPLIB' index 123;

function RasIteratorGetFlag;                           external 'RASOPLIB' index 124;

function SingleRasElemIteratorInit;                    external 'RASOPLIB' index 126;
function SingleRasElemIteratorRun;                     external 'RASOPLIB' index 127;

procedure  SetHlaskaRasOpLib;                          external 'RASOPLIB' index 130;


end.
