// ************************************************************************ //
// The types declared in this file were generated from data read from the
// WSDL File described below:
// WSDL     : d:\dokumenty\DATA\ISKN\WSDP_9_0_20191017\ISKN\ws28\ctios\ctios_v28.wsdl
//  >Import : d:\dokumenty\DATA\ISKN\WSDP_9_0_20191017\ISKN\ws28\ctios\ctios_v28.wsdl>0
//  >Import : d:\dokumenty\DATA\ISKN\WSDP_9_0_20191017\ISKN\ws28\ctios\ctios_v28.xsd
//  >Import : d:\dokumenty\DATA\ISKN\WSDP_9_0_20191017\ISKN\xsd\commonTypes_v28.xsd
//  >Import : d:\dokumenty\DATA\ISKN\WSDP_9_0_20191017\ISKN\xsd\baseTypes_v28.xsd
// (03.06.2020 14:16:16 - - $Rev: 96726 $)
// ************************************************************************ //

unit ctios_v28;

interface

uses Soap.InvokeRegistry, Soap.SOAPHTTPClient, System.Types, Soap.XSBuiltIns;

const
  IS_OPTN = $0001;
  IS_UNBD = $0002;
  IS_ATTR = $0010;
  IS_TEXT = $0020;


type

  // ************************************************************************ //
  // The following types, referred to in the WSDL document are not being represented
  // in this file. They are either aliases[@] of other types represented or were referred
  // to but never[!] declared in the document. The types from the latter category
  // typically map to predefined/known XML or Embarcadero types; however, they could also
  // indicate incorrect WSDL documents that failed to declare or import a schema type.
  // ************************************************************************ //
  // !:nonNegativeInteger - "http://www.w3.org/2001/XMLSchema"[Gbl]
  // !:string          - "http://www.w3.org/2001/XMLSchema"[Gbl]

  CtiOsResponseType    = class;                 { "http://katastr.cuzk.cz/ctios/types/v2.8"[Lit][GblCplx] }
  CtiOsResponse        = class;                 { "http://katastr.cuzk.cz/ctios/types/v2.8"[Lit][GblElm] }
  OSType               = class;                 { "http://katastr.cuzk.cz/ctios/types/v2.8"[GblCplx] }
  ZpravaServeruType    = class;                 { "http://katastr.cuzk.cz/commonTypes/v2.8"[GblCplx] }

  {$SCOPEDENUMS ON}
  { "http://katastr.cuzk.cz/ctios/types/v2.8"[GblSmpl] }
  ChybaPOSIdentType = (NEPLATNY_IDENTIFIKATOR, EXPIROVANY_IDENTIFIKATOR, OPRAVNENY_SUBJEKT_NEEXISTUJE);

  { "http://katastr.cuzk.cz/baseTypes/v2.8"[GblSmpl] }
  ZpravaServeruTypeType = (INFORMACE, VAROVANI, CHYBA);

  {$SCOPEDENUMS OFF}

  OSListType = array of OSType;                 { "http://katastr.cuzk.cz/ctios/types/v2.8"[GblCplx] }
  ResponseInfoType = array of ZpravaServeruType;   { "http://katastr.cuzk.cz/commonTypes/v2.8"[GblCplx] }


  // ************************************************************************ //
  // XML       : CtiOsResponseType, global, <complexType>
  // Namespace : http://katastr.cuzk.cz/ctios/types/v2.8
  // Serializtn: [xoLiteralParam]
  // Info      : Wrapper
  // ************************************************************************ //
  CtiOsResponseType = class(TRemotable)
  private
    Fvysledek: ResponseInfoType;
    FosList: OSListType;
    FosList_Specified: boolean;
    procedure SetosList(Index: Integer; const AOSListType: OSListType);
    function  osList_Specified(Index: Integer): boolean;
  public
    constructor Create; override;
    destructor Destroy; override;
  published
    property vysledek: ResponseInfoType  read Fvysledek write Fvysledek;
    property osList:   OSListType        Index (IS_OPTN) read FosList write SetosList stored osList_Specified;
  end;



  // ************************************************************************ //
  // XML       : CtiOsResponse, global, <element>
  // Namespace : http://katastr.cuzk.cz/ctios/types/v2.8
  // Info      : Wrapper
  // ************************************************************************ //
  CtiOsResponse = class(CtiOsResponseType)
  private
  published
  end;

  CtiOsRequestType = array of string;           { "http://katastr.cuzk.cz/ctios/types/v2.8"[Lit][GblCplx] }
  CtiOsRequest    =  type CtiOsRequestType;      { "http://katastr.cuzk.cz/ctios/types/v2.8"[Lit][GblElm] }
  TextType        =  type string;      { "http://katastr.cuzk.cz/baseTypes/v2.8"[GblSmpl] }


  // ************************************************************************ //
  // XML       : OSType, global, <complexType>
  // Namespace : http://katastr.cuzk.cz/ctios/types/v2.8
  // ************************************************************************ //
  OSType = class(TRemotable)
  private
    FpOSIdent: string;
    FchybaPOSIdent: ChybaPOSIdentType;
    FchybaPOSIdent_Specified: boolean;
    procedure SetchybaPOSIdent(Index: Integer; const AChybaPOSIdentType: ChybaPOSIdentType);
    function  chybaPOSIdent_Specified(Index: Integer): boolean;
  published
    property pOSIdent:      string             read FpOSIdent write FpOSIdent;
    property chybaPOSIdent: ChybaPOSIdentType  Index (IS_OPTN) read FchybaPOSIdent write SetchybaPOSIdent stored chybaPOSIdent_Specified;
  end;



  // ************************************************************************ //
  // XML       : ZpravaServeruType, global, <complexType>
  // Namespace : http://katastr.cuzk.cz/commonTypes/v2.8
  // ************************************************************************ //
  ZpravaServeruType = class(TRemotable)
  private
    FText: TextType;
    Fkod: TXSDecimal;
    Furoven: ZpravaServeruTypeType;
  public
    destructor Destroy; override;
  published
    property Text:   TextType               Index (IS_TEXT) read FText write FText;
    property kod:    TXSDecimal             Index (IS_ATTR) read Fkod write Fkod;
    property uroven: ZpravaServeruTypeType  Index (IS_ATTR) read Furoven write Furoven;
  end;


  // ************************************************************************ //
  // Namespace : http://katastr.cuzk.cz/ctios/v2.8
  // soapAction: http://katastr.cuzk.cz/ctios/ctios
  // transport : http://schemas.xmlsoap.org/soap/http
  // style     : document
  // use       : literal
  // binding   : ctiosSOAPBinding
  // service   : ctios
  // port      : ctiosSoapHttpPort
  // URL       : https://katastr.cuzk.cz/ws/ctios/2.8/ctios
  // ************************************************************************ //
  ctios = interface(IInvokable)
  ['{A48721E4-06D1-BC6E-AEFC-894086592529}']

    // Cannot unwrap:
    //     - Input element wrapper name does not match operation's name
    //     - More than one strictly out element was found
    function  ctios(const input: CtiOsRequest): CtiOsResponse; stdcall;
  end;

function Getctios(UseWSDL: Boolean=System.False; Addr: string=''; HTTPRIO: THTTPRIO = nil): ctios;


implementation
  uses System.SysUtils;

function Getctios(UseWSDL: Boolean; Addr: string; HTTPRIO: THTTPRIO): ctios;
const
  defWSDL = 'd:\dokumenty\DATA\ISKN\WSDP_9_0_20191017\ISKN\ws28\ctios\ctios_v28.wsdl';
  defURL  = 'https://katastr.cuzk.cz/ws/ctios/2.8/ctios';
  defSvc  = 'ctios';
  defPrt  = 'ctiosSoapHttpPort';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  if HTTPRIO = nil then
    RIO := THTTPRIO.Create(nil)
  else
    RIO := HTTPRIO;
  try
    Result := (RIO as ctios);
    if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
  finally
    if (Result = nil) and (HTTPRIO = nil) then
      RIO.Free;
  end;
end;


constructor CtiOsResponseType.Create;
begin
  inherited Create;
  FSerializationOptions := [xoLiteralParam];
end;

destructor CtiOsResponseType.Destroy;
var
  I: Integer;
begin
  for I := 0 to System.Length(Fvysledek)-1 do
    System.SysUtils.FreeAndNil(Fvysledek[I]);
  System.SetLength(Fvysledek, 0);
  for I := 0 to System.Length(FosList)-1 do
    System.SysUtils.FreeAndNil(FosList[I]);
  System.SetLength(FosList, 0);
  inherited Destroy;
end;

procedure CtiOsResponseType.SetosList(Index: Integer; const AOSListType: OSListType);
begin
  FosList := AOSListType;
  FosList_Specified := True;
end;

function CtiOsResponseType.osList_Specified(Index: Integer): boolean;
begin
  Result := FosList_Specified;
end;

procedure OSType.SetchybaPOSIdent(Index: Integer; const AChybaPOSIdentType: ChybaPOSIdentType);
begin
  FchybaPOSIdent := AChybaPOSIdentType;
  FchybaPOSIdent_Specified := True;
end;

function OSType.chybaPOSIdent_Specified(Index: Integer): boolean;
begin
  Result := FchybaPOSIdent_Specified;
end;

destructor ZpravaServeruType.Destroy;
begin
  System.SysUtils.FreeAndNil(Fkod);
  inherited Destroy;
end;

initialization
  { ctios }
  InvRegistry.RegisterInterface(TypeInfo(ctios), 'http://katastr.cuzk.cz/ctios/v2.8', '');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(ctios), 'http://katastr.cuzk.cz/ctios/ctios');
  InvRegistry.RegisterInvokeOptions(TypeInfo(ctios), ioDocument);
  InvRegistry.RegisterInvokeOptions(TypeInfo(ctios), ioLiteral);
  RemClassRegistry.RegisterXSInfo(TypeInfo(OSListType), 'http://katastr.cuzk.cz/ctios/types/v2.8', 'OSListType');
  RemClassRegistry.RegisterXSInfo(TypeInfo(ChybaPOSIdentType), 'http://katastr.cuzk.cz/ctios/types/v2.8', 'ChybaPOSIdentType');
  RemClassRegistry.RegisterXSInfo(TypeInfo(ResponseInfoType), 'http://katastr.cuzk.cz/commonTypes/v2.8', 'ResponseInfoType');
  RemClassRegistry.RegisterXSClass(CtiOsResponseType, 'http://katastr.cuzk.cz/ctios/types/v2.8', 'CtiOsResponseType');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(CtiOsResponseType), 'vysledek', '[ArrayItemName="zprava"]');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(CtiOsResponseType), 'osList', '[ArrayItemName="os"]');
  RemClassRegistry.RegisterSerializeOptions(CtiOsResponseType, [xoLiteralParam]);
  RemClassRegistry.RegisterXSClass(CtiOsResponse, 'http://katastr.cuzk.cz/ctios/types/v2.8', 'CtiOsResponse');
  RemClassRegistry.RegisterXSInfo(TypeInfo(CtiOsRequestType), 'http://katastr.cuzk.cz/ctios/types/v2.8', 'CtiOsRequestType');
  RemClassRegistry.RegisterSerializeOptions(TypeInfo(CtiOsRequestType), [xoLiteralParam]);
  RemClassRegistry.RegisterXSInfo(TypeInfo(CtiOsRequest), 'http://katastr.cuzk.cz/ctios/types/v2.8', 'CtiOsRequest');
  RemClassRegistry.RegisterXSInfo(TypeInfo(TextType), 'http://katastr.cuzk.cz/baseTypes/v2.8', 'TextType');
  RemClassRegistry.RegisterXSClass(OSType, 'http://katastr.cuzk.cz/ctios/types/v2.8', 'OSType');
  RemClassRegistry.RegisterXSInfo(TypeInfo(ZpravaServeruTypeType), 'http://katastr.cuzk.cz/baseTypes/v2.8', 'ZpravaServeruTypeType');
  RemClassRegistry.RegisterXSClass(ZpravaServeruType, 'http://katastr.cuzk.cz/commonTypes/v2.8', 'ZpravaServeruType');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(ZpravaServeruType), 'uroven', '[Namespace="http://katastr.cuzk.cz/baseTypes/v2.8"]');

end.
