unit r_ThematicLinesLayerEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  r_ThematicLayerEditor, ExtCtrls, StdCtrls,
  e_ThematicMap;

type
  TThematicLinesLayerEditor_Frame = class(TThematicLayerEditor_Frame)
    cb_LinePoints: TCheckBox;
    cb_SimpleLines: TCheckBox;
    cb_Barva0: TCheckBox;
    procedure cb_LinePointsClick(Sender: TObject);
    procedure cb_SimpleLinesClick(Sender: TObject);
    procedure cb_Barva0Click(Sender: TObject);
  private
    { Private declarations }
  public
     procedure SetLayer(const Value: TThematicLayer); override;
  end;


implementation

{$R *.DFM}

procedure TThematicLinesLayerEditor_Frame.cb_LinePointsClick(
  Sender: TObject);
begin
   inherited;
   Layer.LinePoints := cb_LinePoints.Checked;
end;

procedure TThematicLinesLayerEditor_Frame.cb_SimpleLinesClick(
  Sender: TObject);
begin
   inherited;
   Layer.SimpleLines := cb_SimpleLines.Checked;
end;

procedure TThematicLinesLayerEditor_Frame.SetLayer(const Value: TThematicLayer);
begin
   inherited;
   if not (TObject(Value) is TThematicLayer) then exit;
   cb_LinePoints.Checked := Value.LinePoints;
   cb_SimpleLines.Checked := Value.SimpleLines;
end;

procedure TThematicLinesLayerEditor_Frame.cb_Barva0Click(Sender: TObject);
begin
   inherited;
   Layer.FillBackGround := cb_Barva0.Checked;
end;

end.
