unit Rasdata_TLB;

// ************************************************************************ //
// WARNING                                                                  //
// -------                                                                  //
// The types declared in this file were generated from data read from a     //
// Type Library. If this type library is explicitly or indirectly (via      //
// another type library referring to this type library) re-imported, or the //
// 'Refresh' command of the Type Library Editor activated while editing the //
// Type Library, the contents of this file will be regenerated and all      //
// manual modifications will be lost.                                       //
// ************************************************************************ //

// PASTLWTR : $Revision:   1.11.1.63.1.0.1.0  $
// File generated on 4.11.1998 15:43:21 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\Program Files\Common Files\TopoLNT\Rasdata.tlb
// IID\LCID: {C1F953C1-FE91-11D0-BC6B-0000E80ADAFB}\0
// Helpfile: 
// HelpString: 
// Version:    1.0
// ************************************************************************ //

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLASS_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
const
  LIBID_Rasdata: TGUID = '{C1F953C1-FE91-11D0-BC6B-0000E80ADAFB}';
  DIID_IRaster: TGUID = '{C1F953C4-FE91-11D0-BC6B-0000E80ADAFB}';
  CLASS_Raster: TGUID = '{C1F953C5-FE91-11D0-BC6B-0000E80ADAFB}';
  DIID_IPalette: TGUID = '{7B629E00-8748-11D0-BC6B-0000E80ADAFB}';
  CLASS_Palette: TGUID = '{7B629E01-8748-11D0-BC6B-0000E80ADAFB}';
type

// *********************************************************************//
// Forward declaration of interfaces defined in Type Library            //
// *********************************************************************//
  IRaster = dispinterface;
  IPalette = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
// *********************************************************************//
  Raster = IRaster;
  Palette = IPalette;


// *********************************************************************//
// Declaration of structures, unions and aliases.                       //
// *********************************************************************//
  PInteger1 = ^Integer; {*}
  PDouble1 = ^Double; {*}
  POleVariant1 = ^OleVariant; {*}


// *********************************************************************//
// DispIntf:  IRaster
// Flags:     (4096) Dispatchable
// GUID:      {C1F953C4-FE91-11D0-BC6B-0000E80ADAFB}
// *********************************************************************//
  IRaster = dispinterface
    ['{C1F953C4-FE91-11D0-BC6B-0000E80ADAFB}']
    property IsOpen: WordBool dispid 1;
    property FileName: WideString dispid 2;
    property OpenRW: Integer dispid 3;
    property Access: Integer dispid 4;
    property FileFormat: WideString dispid 5;
    property Width: Integer dispid 6;
    property Height: Integer dispid 7;
    property BitPix: Smallint dispid 8;
    property RasTyp: Smallint dispid 9;
    property Compres: Smallint dispid 10;
    property DefCol: Integer dispid 11;
    property Note: WideString dispid 12;
    property X1: Double dispid 13;
    property Y1: Double dispid 14;
    property Dx: Double dispid 15;
    property Dy: Double dispid 16;
    property CoordOri: Integer dispid 17;
    property Palette: IDispatch dispid 18;
    property ErrorStr: WideString dispid 19;
    property Tiled: WordBool dispid 20;
    property IsMasked: Integer dispid 21;
    property Sketch: Integer dispid 22;
    property FileSize: Integer dispid 23;
    property VertRes: Double dispid 24;
    property HorzRes: Double dispid 25;
    property Version: Smallint dispid 26;
    property CoordSys: OleVariant dispid 27;
    function OpenRas(const FileName: WideString; OpenRW: Integer; Access: Integer): SCODE; dispid 28;
    function CreateRas(const FileName: WideString; Access: Integer; Init: WordBool): SCODE; dispid 29;
    function CloseRas(Delete: WordBool): SCODE; dispid 30;
    function CopyParRas(const Raster: IDispatch; CopyPal: Integer): SCODE; dispid 31;
    function CopyFrom(const Raster: IDispatch; X1: Integer; Y1: Integer; Dx: Integer; Dy: Integer): SCODE; dispid 32;
    function CopyTo(const Raster: IDispatch; X1: Integer; Y1: Integer): SCODE; dispid 33;
    procedure GeoToPixel(xg: Double; yg: Double; var xpix: Integer; var ypix: Integer; 
                         Clip: WordBool); dispid 34;
    procedure PixelToGeo(xpix: Integer; ypix: Integer; var xg: Double; var yg: Double); dispid 35;
    function GeoCopyFrom(const Ras: IDispatch; X1: Double; Y1: Double; Dx: Double; Dy: Double): SCODE; dispid 36;
    function GetHistogram(var Hist: OleVariant): SCODE; dispid 37;
  end;

// *********************************************************************//
// DispIntf:  IPalette
// Flags:     (4096) Dispatchable
// GUID:      {7B629E00-8748-11D0-BC6B-0000E80ADAFB}
// *********************************************************************//
  IPalette = dispinterface
    ['{7B629E00-8748-11D0-BC6B-0000E80ADAFB}']
    property LenPalette: Integer dispid 1;
    property Format: Integer dispid 2;
    property ErrorStr: WideString dispid 3;
    property LenBufPal: Integer dispid 4;
    property RasTyp: Smallint dispid 5;
    property EntryPalette[Index: Smallint]: Integer dispid 14;
    function SetAllPalette(Sar: OleVariant): SCODE; dispid 6;
    function SetAllTransfer(Sar: OleVariant): SCODE; dispid 7;
    function GenerPal(Colors: Integer; Flag: Integer): SCODE; dispid 8;
    function LoadPal(const FileName: WideString; Flag: Integer): SCODE; dispid 9;
    function SavePal(const FileName: WideString; Flag: Integer): SCODE; dispid 10;
    function CopyFromPal(const From: IDispatch): SCODE; dispid 11;
    function GetAllPalette(var Sar: OleVariant): SCODE; dispid 12;
    function GetAllTransfer(var Sar: OleVariant): SCODE; dispid 13;
  end;

  CoRaster = class
    class function Create: IRaster;
    class function CreateRemote(const MachineName: string): IRaster;
  end;

  CoPalette = class
    class function Create: IPalette;
    class function CreateRemote(const MachineName: string): IPalette;
  end;

implementation

uses ComObj;

class function CoRaster.Create: IRaster;
begin
  Result := CreateComObject(CLASS_Raster) as IRaster;
end;

class function CoRaster.CreateRemote(const MachineName: string): IRaster;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Raster) as IRaster;
end;

class function CoPalette.Create: IPalette;
begin
  Result := CreateComObject(CLASS_Palette) as IPalette;
end;

class function CoPalette.CreateRemote(const MachineName: string): IPalette;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_Palette) as IPalette;
end;

end.
