unit F_TBLGRD99;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, ComCtrls, ExtCtrls, DBCtrls,
  Grids, DBGrids, StdCtrls, Mask, Buttons, Db, BDE, IniFiles,
  DbTables, Menus, Wwdatsrc, Wwintl, Wwfltdlg, Wwlocate, Wwdbigrd,
  Wwdbgrid,wwTable, wwdbedit, Wwdotdot, Wwdbcomb, wwdblook, ToolWin;

type
  TF_TblGrid99 = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel3: TPanel;
    PopupMenu1: TPopupMenu;
    Vyhledn1: TMenuItem;
    Nastavpoli1: TMenuItem;
    wwLocateDlg1: TwwLocateDialog;
    wwDBGrid1: TwwDBGrid;
    wwFilterDialog1: TwwFilterDialog;
    Filtr1: TMenuItem;
    wwIntl1: TwwIntl;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    FAktivniDS: TwwDataSource;
    Duplikujzznam1: TMenuItem;
    N2: TMenuItem;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    DBNavigator1: TDBNavigator;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    ToolButton3: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;

    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure Filtr1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Nastavpoli1Click(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure Vyhledn1Click(Sender: TObject);
    procedure wwDBGrid1TitleButtonClick(Sender: TObject;
      AFieldName: string);
    procedure wwDBGrid1CalcTitleAttributes(Sender: TObject;
      AFieldName: string; AFont: TFont; ABrush: TBrush;
      var ATitleAlignment: TAlignment);
    procedure FormShow(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure wwDBGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure Duplikujzznam1Click(Sender: TObject);
  private
    CanCancelEditMode: Boolean;

//    function  GetAktivniDS: TwwDataSource;

    procedure AfterCancel(DataSet: TDataSet);
    procedure BeforeCancel(DataSet: TDataSet);
    procedure FiltrSelectedFields(aTable: TwwTable);
    procedure GetStautsInfo;
    procedure SetAktivniDS(aValue: TwwDataSource);
    procedure SetBtnsPosition;
    procedure SetStautsInfo;
    procedure TableState(DataSet: TDataSet; StatusBarPom: TStatusBar);
  public

    property AktivniDS: TwwDataSource read FAktivniDS {GetAktivniDS} write SetAktivniDS;

    function  ShowModalCisel: Integer; virtual;
    function  ShowModalPrehled: Integer;

    procedure HandleMessage(var Msg: TMsg; var Handled: Boolean); virtual;

//    procedure SetAktivniDS(aValue: TwwDataSource);
    procedure ZobrazMyNetUserName(MyNetUserName: String;
              StatusBarPom: TStatusBar); virtual;
    procedure ZobrazPocetZazn(PomDS: TDataSource);

  protected
    JeCisel: Boolean;
    EscFromCombo: Boolean;

    function  JePrazdnaTable(PomDS: TDataSource): Boolean;
    function  VratField(Sender: TObject; aTag: Integer): String; virtual;

    procedure AktivniDSStateChange(Sender: TObject);
    procedure DBNavigClick(Sender: TObject; Button: TNavigateBtn;
              ATSheet: TTabSheet); virtual;
    procedure CloseTables; virtual;
    procedure FocusNaBitBtn; virtual;
    procedure KeyUpZmenZazn(Sender: TObject; var Key: Word;
              Shift: TShiftState; DBNavigPom: TDBNavigator); virtual;
    procedure MyFormCreate(Sender: TObject); virtual;
    procedure MyFormCloseQuery(Sender: TObject;
              var CanClose: Boolean); virtual;
    procedure MyFormKeyUp(Sender: TObject; var Key: Word;
              Shift: TShiftState); virtual;
    procedure MyVyhledn1Click(Sender: TObject;
              aTag: Integer); virtual;
    procedure NastavEdit(aTag : Integer; aReadOnly : Boolean; aColor : TColor);
    procedure NastavPages(Barva: TColor; Logic: Boolean;
              ATSheet: TTabSheet); virtual;
    procedure NastavShowModalCisel; virtual;
    procedure OpenTables; virtual;
    procedure SaveAllChanges; virtual;
  end;

const
   EditModConst = 'Nejste v editanm mdu, selnk nelze zobrazit!';
   EditModConst2 = 'Nejste v editanm mdu nelze provdt zmny!';
   EditModConst3 = 'Pokud jste v editanm mdu nelze se pepnout na jinou strnku!';
   PrazdnaConst = 'Pokud je evidence prazdn nelze se pepnout na jinou strnku!';

var
  F_TblGrid99: TF_TblGrid99;

implementation


{$R *.DFM}

uses u_BDELib, u_DBTyps, u_DBLib, m_Tables;


{
function TF_TblGrid.GetAktivniDS: TwwDataSource;
begin
   if FAktivniDS = nil then FAktivniDS := TwwDataSource.create(F_TblGrid);

   Result := FAktivniDS;
end;
}


procedure TF_TblGrid99.SetAktivniDS(aValue: TwwDataSource);
begin
   {Pipojm nov datov zdroj}

   FAktivniDS.Dataset := aValue.Dataset;

   If FAktivniDS = nil then Exit;

   FAktivniDS.OnStateChange := AktivniDSStateChange;

   (TwwTable(FAktivniDS.DataSet)).BeforeCancel :=  BeforeCancel;
   (TwwTable(FAktivniDS.DataSet)).AfterCancel :=  AfterCancel;

   GetStautsInfo;

   orbOpenDataSource(FAktivniDS);
{
   if wwFilterDialog1.DataSource <> FAktivniDS then
   begin
      wwFilterDialog1.ClearFilter;
      wwFilterDialog1.DataSource := FAktivniDS;
      TableState(FAktivniDS.DataSet, StatusBar1)
   end;
 }

   TableState(FAktivniDS.DataSet, StatusBar1);

   ZobrazPocetZazn(FAktivniDS);
end;


(*
procedure TF_TblGrid.SetAktivniDS(aValue: TwwDataSource);
begin
   {Pipojm nov datov zdroj}

   AktivniDS := aValue;

   If AktivniDS = nil then Exit;

   AktivniDS.OnStateChange := AktivniDSStateChange;

   (TwwTable(AktivniDS.DataSet)).BeforeCancel :=  BeforeCancel;
   (TwwTable(AktivniDS.DataSet)).AfterCancel :=  AfterCancel;

   GetStautsInfo;

   orbOpenDataSource(AktivniDS);

{
   with TwwTable(FAktivniDS.Dataset) do
   begin
      if State = dsInactive then Active := True;
   end;
}

   if wwFilterDialog1.DataSource <> AktivniDS then
   begin
      wwFilterDialog1.ClearFilter;
      wwFilterDialog1.DataSource := AktivniDS;
      TableState(AktivniDS.DataSet, StatusBar1)
   end;

   ZobrazPocetZazn(AktivniDS);

end;
*)


procedure TF_TblGrid99.DBNavigator1Click(Sender: TObject;
  Button: TNavigateBtn);
begin
   CanCancelEditMode := True;
   DBNavigClick(Sender, Button, PageControl1.ActivePage);
end;



procedure TF_TblGrid99.DBNavigClick(Sender: TObject; Button: TNavigateBtn;
          ATSheet: TTabSheet);
begin
   case Button of
      nbFirst  : FocusNaBitBtn;
      nbPrior  : FocusNaBitBtn;
      nbNext   : FocusNaBitBtn;
      nbLast   : FocusNaBitBtn;
      nbInsert : NastavPages(clWindow, False, ATSheet);

      nbDelete :
      begin
         ZobrazPocetZazn(AktivniDs);
         FocusNaBitBtn;
      end;

      nbEdit   : NastavPages(clWindow, False, ATSheet);

      nbPost   :
      begin
         NastavPages(clBtnFace, True, ATSheet);
         ZobrazPocetZazn(AktivniDs);
      end;

      nbCancel :
      begin
         NastavPages(clBtnFace, True, ATSheet);
      end;

      nbRefresh:
      begin
         ZobrazPocetZazn(AktivniDs);
         FocusNaBitBtn;
      end;
   end;

end;



procedure TF_TblGrid99.FocusNaBitBtn;
begin
{
Je-li Form zobrazen jako selnk je vidt pouze
BitBtn2 a BitBtn3, Jinak BitBtn1
   if JeCisel then
      BitBtn3.SetFocus
   else
}
      BitBtn1.SetFocus;
end;



procedure TF_TblGrid99.FormCreate(Sender: TObject);
begin
   EscFromCombo:= False;
   GetStautsInfo;
   MyFormCreate(Sender);
   screen.cursor := crDefault;
end;



procedure TF_TblGrid99.MyFormCreate(Sender: TObject);
begin

{
   wwLocateDlg1.DataSource := AktivniDs;
   wwFilterDialog1.DataSource := AktivniDs;
 }

   if not (AktivniDS.Dataset is TwwTable) then
      Application.terminate;

   OpenTables;

   TableState(AktivniDS.DataSet, StatusBar1);
   ZobrazMyNetUserName(u_BDELib.orbfDbiGetMyNetUserName, StatusBar1);

   JeCisel := False;
   CanCancelEditMode := False;

end;



procedure TF_TblGrid99.CloseTables;
begin
  if AktivniDS = nil then exit;

  orbCloseDataSet(AktivniDS.Dataset);
end;



procedure TF_TblGrid99.OpenTables;
begin
  if AktivniDS = nil then exit;

   orbOpenDataSource(AktivniDS);
end;



procedure TF_TblGrid99.GetStautsInfo;
var
   IniFile: TIniFile;
   Status: Integer;
begin
   IniFile := TIniFile.Create(OrbGetAppName + '.Ini');
   Status := IniFile.ReadInteger(Name,'STATUS',0);
   if Status <> 0 then
   begin
      Top := IniFile.ReadInteger(Name,'Top', Top);
      Left := IniFile.ReadInteger(Name,'Left', Left);
      Width := IniFile.ReadInteger(Name,'Width', Width);
      Height := IniFile.ReadInteger(Name,'Height', Height);
      case Status of
         1: WindowState := wsNormal;
         2: PostMessage (F_TblGrid.Handle, wm_SysCommand, sc_Minimize, 0);
         3: WindowState := wsMaximized;
      end;
   end;

   SetBtnsPosition;
   IniFile.Free;

end;



procedure TF_TblGrid99.SetStautsInfo;
var
   IniFile: TIniFile;
   Status: Integer;
begin
   IniFile := TIniFile.Create(orbGetAppName + '.Ini');
   Status := 1;

   case WindowState  of
      wsNormal:
      begin
         IniFile.WriteInteger(Name,'Top', Top);
         IniFile.WriteInteger(Name,'Left', Left);
         IniFile.WriteInteger(Name,'Width', Width);
         IniFile.WriteInteger(Name,'Height', Height);

      end;
      wsMinimized: Status := 2;
      wsMaximized: Status := 3;
   end;
   IniFile.WriteInteger(Name,'STATUS',Status);
   IniFile.Free;
end;



procedure TF_TblGrid99.AktivniDSStateChange(Sender: TObject);
begin
   if not (Sender is TwwDataSource) then exit;

   TableState((TwwDataSource(Sender)).DataSet, StatusBar1)
end;



procedure TF_TblGrid99.BeforeCancel(DataSet: TDataSet);
begin
   if not (DataSet is TwwTable) then exit;

   if ((not CanCancelEditMode) and
       (not orbDataSetApplyUpdates(DataSet, True))) then
        SysUtils.Abort;
end;



procedure TF_TblGrid99.AfterCancel(DataSet: TDataSet);
begin
   if not (DataSet is TwwTable) then exit;

   NastavPages(clBtnFace, True, PageControl1.ActivePage);
end;



procedure TF_TblGrid99.NastavPages(Barva: TColor; Logic: Boolean;
   aTSheet: TTabSheet);
begin

   case aTSheet.PageIndex of
      0:
      begin
         NastavEdit(1, Logic, Barva);
         if Logic then
            FocusNaBitBtn
         else
            wwDBGrid1.SetFocus;
      end;
   end;
end;



procedure TF_TblGrid99.TableState(DataSet: TDataSet; StatusBarPom: TStatusBar);
var
   aFiltr: String;
begin
{
   TDataSetState = (dsInactive, dsBrowse, dsEdit, dsInsert, dsSetKey,
                    dsCalcFields, dsUpdateNew, dsUpdateOld, dsFilter);
}
   aFiltr :='';
   if not (DataSet is TwwTable) then exit;

//   if TwwTable(Dataset).Filtered then aFiltr :='Filtr/';

   if wwFilterDialog1.FieldInfo.Count > 0 then aFiltr := 'Filtr/';

   with DataSet do
   begin
      with StatusBarPom.Panels do
      begin
         Items[1].Text := '';
         Items[3].Text := '';

         if state = dsBrowse then Items[1].Text := aFiltr + 'Prohlen'
         else if state = dsEdit then Items[1].Text := aFiltr + 'Oprava'
         else if state = dsInsert then Items[1].Text := aFiltr + 'Nov'
         else if state = dsSetKey then Items[3].Text := 'Pipravuji filtr ...'
         else if state = dsCalcFields then
                 Items[3].Text := 'Pipravuji kalkulovan poloky ...'
         else if state = dsFilter then Items[3].Text := 'Nastavuji filtr ...';

      end;
   end;

   Application.ProcessMessages;

end;



function TF_TblGrid99.JePrazdnaTable(PomDS: TDataSource): Boolean;
begin
   Result := True;
   if not (PomDS.Dataset is TTable) then exit;

   with TTable(PomDS.Dataset) do
   begin
      if (RecordCount > 0) then Result := False;
   end;

end;



procedure TF_TblGrid99.ZobrazPocetZazn(PomDS: TDataSource);
var
  PocetZazn: Integer;
begin
   if not (PomDS.Dataset is TTable) then exit;

   PocetZazn := (TTable(PomDS.Dataset)).RecordCount;
   StatusBar1.Panels.Items[0].Text := IntToStr(PocetZazn);
   Application.ProcessMessages;
end;



procedure TF_TblGrid99.HandleMessage(var Msg: TMsg; var Handled: Boolean);
begin
   Handled := true;

   case Msg.WPARAM of
      tm_OpenTables: OpenTables;
      tm_CloseTables: CloseTables;
   end;
end;



procedure TF_TblGrid99.ZobrazMyNetUserName(MyNetUserName: String;
  StatusBarPom: TStatusBar);
begin
   StatusBarPom.Panels.Items[2].Text := MyNetUserName;
   Application.ProcessMessages;
end;



procedure TF_TblGrid99.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SetStautsInfo;
   Action:= caFree;
end;



procedure TF_TblGrid99.Vyhledn1Click(Sender: TObject);
begin
   MyVyhledn1Click(Sender, PageControl1.ActivePage.PageIndex + 1);
end;



procedure TF_TblGrid99.MyVyhledn1Click(Sender: TObject;
   aTag: Integer);
var
  i: integer;
begin
   if not u_DBLib.orbIsInsertEditMode(AktivniDS) then
   begin
      if wwLocateDlg1.DataSource <> AktivniDS then
         wwLocateDlg1.DataSource := AktivniDS;

      for i := 0 to ComponentCount - 1 do
      begin
         if Components[i].Tag = aTag then
         begin
            if Components[i] is TwwDBGrid then
            begin
               wwLocateDlg1.SearchField :=
                  TwwDBGrid(Components[i]).SelectedField.FieldName;
               Break;
            end;
         end;
      end;

      wwLocateDlg1.execute;
   end;

{
   if not u_DBLib.IsInsertEditMode(AktivniDS) then
   begin
      if (PageControl1.ActivePage = TabSheet1) then
      begin
         wwLocateDlg1.DataSource := AktivniDS;
         wwLocateDlg1.SearchField :=
            wwDBGrid1.SelectedField.FieldName;
         wwLocateDlg1.execute;
      end;
   end;
}
end;



procedure TF_TblGrid99.Nastavpoli1Click(Sender: TObject);
begin
  if not u_DBLib.orbIsInsertEditMode(AktivniDS) then
  begin
     if not (AktivniDS.Dataset is TwwTable) then exit;

//     VyberFields(TTable(AktivniDS.Dataset));

     u_DBLib.orbDlgSetFields(TwwTable(AktivniDS.Dataset));
  end;
end;



procedure TF_TblGrid99.NastavEdit(aTag : Integer; aReadOnly : Boolean; aColor : TColor);
var
   i : Integer;
begin
   Screen.Cursor := crHourGlass;

   for i := 0 to ComponentCount - 1 do
   begin
      if Components[i].Tag = aTag then
      begin
         if Components[i] is TwwDBGrid then
         begin
            TwwDBGrid(Components[i]).ReadOnly := aReadOnly;
            TwwDBGrid(Components[i]).Color := aColor;
         end

         else if Components[i] is TwwDBCombobox then
         begin
            TwwDBCombobox(Components[i]).ReadOnly := aReadOnly;
            TwwDBCombobox(Components[i]).ShowButton := not aReadOnly;
            TwwDBCombobox(Components[i]).Color := aColor;
         end

         else if Components[i] is TDBComboBox then
         begin
            TDBComboBox(Components[i]).ReadOnly := aReadOnly;
            TDBComboBox(Components[i]).Color := aColor;
         end

         else if Components[i] is TwwDBComboDlg then
         begin
            TwwDBComboDlg(Components[i]).ReadOnly := aReadOnly;
            TwwDBComboDlg(Components[i]).ShowButton := not aReadOnly;
            TwwDBComboDlg(Components[i]).Color := aColor;
         end

         else if Components[i] is TwwDBLookupCombo then
         begin
            TwwDBLookupCombo(Components[i]).ReadOnly := aReadOnly;
            TwwDBLookupCombo(Components[i]).ShowButton := not aReadOnly;
            TwwDBLookupCombo(Components[i]).Color := aColor;
         end

         else if Components[i] is TDBCheckBox then
         begin
            TDBCheckBox(Components[i]).ReadOnly := aReadOnly;
         end

         else if Components[i] is TDBRadioGroup then
         begin
            TDBRadioGroup(Components[i]).ReadOnly := aReadOnly;
         end

         else if Components[i] is TwwDBEdit then
         begin
            TwwDBEdit(Components[i]).ReadOnly := aReadOnly;
            TwwDBEdit(Components[i]).Color := aColor;
         end

         else if Components[i] is TDBMemo then
         begin
            TDBMemo(Components[i]).ReadOnly := aReadOnly;
            TDBMemo(Components[i]).Color := aColor;
         end

         else if Components[i] is TDBGrid then
         begin
            TDBGrid(Components[i]).ReadOnly := aReadOnly;
            TDBGrid(Components[i]).Color := aColor;
         end

         else if Components[i] is TDBEdit then
         begin
            TDBEdit(Components[i]).ReadOnly := aReadOnly;
            TDBEdit(Components[i]).Color := aColor;
         end

         else if Components[i] is TBitBtn then
         begin
            TBitBtn(Components[i]).Enabled := not aReadOnly;
         end;

      end;
   end;
   Screen.Cursor := crDefault;
end;



procedure TF_TblGrid99.PageControl1Changing(Sender: TObject;
   var AllowChange: Boolean);
begin
   if u_DBLib.orbIsInsertEditMode(AktivniDS) then
   begin
      AllowChange := False;
      ShowMessage('Pokud jste v editanm mdu nelze se pepnout na jinou strnku.');
   end;
end;



procedure TF_TblGrid99.FiltrSelectedFields(aTable: TwwTable);
var
   i: integer;
begin
   wwFilterDialog1.SelectedFields.Clear;

   for i := 0 to aTable.FieldCount - 1 do
   begin
      if aTable.Fields[i].Visible then
         wwFilterDialog1.SelectedFields.Add(aTable.Fields[i].FieldName);
   end;

end;



procedure TF_TblGrid99.Filtr1Click(Sender: TObject);
begin
  if not u_DBLib.orbIsInsertEditMode(AktivniDS) then
  begin
     if not (AktivniDS.Dataset is TwwTable) then exit;
{ eeno v propert AktivniDS
     if wwFilterDialog1.DataSource <> AktivniDS then
     begin
        wwFilterDialog1.ClearFilter;
        wwFilterDialog1.DataSource := AktivniDS;
     end;
}
     FiltrSelectedFields(TwwTable(AktivniDS.Dataset));
     wwFilterDialog1.DefaultField :=
       VratField(Sender, PageControl1.ActivePage.PageIndex + 1);

     wwFilterDialog1.Execute;

     TableState(AktivniDS.DataSet, StatusBar1)

  end;
end;



function TF_TblGrid99.VratField(Sender: TObject; aTag: Integer): String;
var
   i: Integer;
begin
   Result := '';
   for i := 0 to ComponentCount - 1 do
   begin
      if Components[i].Tag = aTag then
      begin
         if Components[i] is TwwDBGrid then
         begin
            Result := TwwDBGrid(Components[i]).SelectedField.FieldName;
            Break;
         end;
      end;
   end;
end;



procedure TF_TblGrid99.wwDBGrid1TitleButtonClick(Sender: TObject;
  AFieldName: string);
begin
      if not (AktivniDS.Dataset is TwwTable) then exit;

      try
         (TwwTable(AktivniDS.Dataset)).IndexFieldNames := AFieldName;
      except
         {Kdy se nastaven novho indexu nepoda zstane pvodn}
      end;
end;



procedure TF_TblGrid99.wwDBGrid1CalcTitleAttributes(Sender: TObject;
  AFieldName: string; AFont: TFont; ABrush: TBrush;
  var ATitleAlignment: TAlignment);
{
var
   i, maxi: integer;
}
begin

   if not (AktivniDS.Dataset is TwwTable) then exit;

   if (uppercase(AFieldName) =
      uppercase((TwwTable(AktivniDS.Dataset)).indexFieldNames)) then
      ABrush.Color:= clYellow;
{
   wwDbgrid1.Hint := AFieldName;
   maxi := (AktivniDS.Dataset).IndexFieldCount - 1;
   for i := 0 to  maxi do
   begin
      if (uppercase(AFieldName) =
      uppercase((TTable(AktivniDS.Dataset)).IndexFields[i].FieldName)) then
      begin
         wwDbgrid1.Hint :=
          'Stlaenm tlatka setdte tabulku podle tohoto sloupce';
         break;
      end;
   end;
}
end;



procedure TF_TblGrid99.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   MyFormCloseQuery(Sender, CanClose);
end;



procedure TF_TblGrid99.MyFormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   CanClose := True;

   if u_DBLib.orbIsInsertEditMode(AktivniDS) then
   begin
      if (MessageDlg(
         'Provdn zmny nejsou uloeny, chcete pesto skonit?',
         mtConfirmation, [mbYes, mbCancel], 0) = mrYes) then
      begin
         TwwTable(AktivniDS.Dataset).Cancel;
         CanClose := True;
      end
      else
         CanClose := False;

   end;

   if CanClose then SaveAllChanges;

end;



procedure TF_TblGrid99.SaveAllChanges;
begin
{
   if orbIsOpenMode(AktivniDS)  then
      Showmessage('Open')
   else
      Showmessage('Close');
}
{
    wwLocateDlg1.DataSource := nil;
    wwFilterDialog1.DataSource := nil;
    AktivniDS := nil;
}
    AktivniDS.Dataset := nil;
end;



function TF_TblGrid99.ShowModalCisel: Integer;
begin
  BitBtn1.visible := Ture;
  BitBtn2.visible := True;
//  BitBtn3.visible := True;
  NastavShowModalCisel;

  DBNavigator1.VisibleButtons :=
   [nbFirst,nbPrior,nbNext,nbLast,nbInsert,nbEdit,nbPost,nbCancel,nbRefresh];

  JeCisel := True;
  Result := ShowModal;
end;



function TF_TblGrid99.ShowModalPrehled: Integer;
begin
  BitBtn1.visible := True;
  BitBtn2.visible := False;
 // BitBtn3.visible := False;
  NastavShowModalCisel;

  DBNavigator1.VisibleButtons :=
   [nbFirst,nbPrior,nbNext,nbLast,nbRefresh];

  JeCisel := False;
  Result := ShowModal;
end;



procedure TF_TblGrid99.NastavShowModalCisel;
begin
  Caption := 'Vyberte si z selnku ...';
end;



procedure TF_TblGrid99.KeyUpZmenZazn(Sender: TObject; var Key: Word;
  Shift: TShiftState; DBNavigPom: TDBNavigator);
begin
{
TNavigateBtn = (nbFirst, nbPrior, nbNext, nbLast, nbInsert, nbDelete,
   nbEdit, nbPost, nbCancel, nbRefresh);
}
   {Mazn zznamu}
   if ((Shift = [ssCtrl]) and (Key = VK_DELETE)) then DBNavigPom.BtnClick(nbDelete);

   {Oprava a ukldn zznamu}
   if (Key = VK_F9) then
   begin
      if u_DBLib.orbIsInsertEditMode(AktivniDS) then
         DBNavigPom.BtnClick(nbPost)
      else
         DBNavigPom.BtnClick(nbEdit);
   end;

   {Vkldn novho zznamu}
   if (Key = VK_Insert) then
   begin
      if (not u_DBLib.orbIsInsertEditMode(AktivniDS)) then DBNavigPom.BtnClick(nbInsert);
   end;

   {Storno zmn zznamu}
   if (Key = VK_Escape) then
   begin
      if u_DBLib.orbIsInsertEditMode(AktivniDS) then
      begin
         if not EscFromCombo then DBNavigPom.BtnClick(nbCancel);  // Neulo zznam

         EscFromCombo := False;
      end
      else
      begin
   //      if BitBtn1.Visible then    // Close Form
            BitBtn1.Click
  //       else
 //           BitBtn3.Click;
      end;
   end;

end;



procedure TF_TblGrid99.MyFormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

   if (PageControl1.ActivePage = TabSheet1) then
       KeyUpZmenZazn(Sender, Key, Shift, DBNavigator1);

end;



procedure TF_TblGrid99.FormShow(Sender: TObject);
begin
   screen.cursor := crDefault;
end;




procedure TF_TblGrid99.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   MyFormKeyUp(Sender, Key, Shift);

end;



procedure TF_TblGrid99.wwDBGrid1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
   if u_DBLib.orbIsInsertEditMode(AktivniDS) then
      CanCancelEditMode := False
   else
      CanCancelEditMode := True;

end;



procedure TF_TblGrid99.Panel3MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
   CanCancelEditMode := True;
end;



procedure TF_TblGrid99.FormResize(Sender: TObject);
begin
   SetBtnsPosition;
end;



procedure TF_TblGrid99.SetBtnsPosition;
begin
//   if BitBtn1.Visible then
   if not JeCisel then
   begin
      BitBtn1.Left := Round((Panel1.Width - 2 - BitBtn1.Width)/2);
   end
   else
   begin
      BitBtn2.Left := Round((Panel1.Width - 2 - BitBtn2.Width
         - 30 - BitBtn3.Width)/2);
      BitBtn1.Left := Round((Panel1.Width - 2 - BitBtn2.Width - 30 - BitBtn1.Width)/2
         + BitBtn2.Width + 30);
   end;

   application.processmessages;
end;



procedure TF_TblGrid99.Duplikujzznam1Click(Sender: TObject);
var
   Buffer: PChar;
begin
   if u_DBLib.orbIsInsertEditMode(AktivniDS) then exit;

   TwwTable(AktivniDS.Dataset).GetCurrentRecord(Buffer);


   DBNavigator1.BtnClick(nbInsert);

//   DBNavigClick(Sender, Button, PageControl1.ActivePage);

end;


INITIALIZATION
   Classes.RegisterClass(TF_TblGrid99);
END.

